<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZExpansion: DayzExpansion/Core/Scripts/3_game/dayzexpansion_core/math/matrix3.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZExpansion<span id="projectnumber">&#160;1.7.12</span>
   </div>
   <div id="projectbrief">DayZExpansion Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('df/de8/a00839_source.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">matrix3.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../df/de8/a00839.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Matrix3.c</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> *</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * DayZ Expansion Mod</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * www.dayzexpansion.com</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> * © 2022 DayZ Expansion Mod Team</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment"> *</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment"> * This work is licensed under the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License.</span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment"> * To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-nd/4.0/.</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment"> *</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment"> */</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span> </div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html">   13</a></span><span class="keyword">class </span><a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span>{</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">   15</a></span>    vector <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[3];</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span> </div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#afa212c2ede422da5b0a728c116bd174a">   17</a></span>    <a class="code hl_class" href="../../da/d67/a04281.html">Transform</a> <a class="code hl_variable" href="../../d1/d66/a04273.html#afa212c2ede422da5b0a728c116bd174a">m_trans</a>;</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span> </div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#a1288ceb8ba5e8307216208c3ba127b15">   19</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d1/d66/a04273.html#a1288ceb8ba5e8307216208c3ba127b15">Transpose</a>(vector a[3], out vector b[3])</div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span>    {</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span>        b[0][0] = a[0][0];</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span>        b[0][1] = a[1][0];</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span>        b[0][2] = a[1][0];</div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span>        b[1][0] = a[0][1];</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span>        b[1][1] = a[1][1];</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span>        b[1][2] = a[1][1];</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span>        b[2][0] = a[0][2];</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span>        b[2][1] = a[1][2];</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span>        b[2][2] = a[1][2];</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span>    }</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span> </div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#afb1d1e5f93a16088273f76ab8968119d">   32</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d1/d66/a04273.html#afb1d1e5f93a16088273f76ab8968119d">Matrix3</a>()</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>    {</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>        <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a> = {<span class="stringliteral">&quot;1 0 0&quot;</span>, <span class="stringliteral">&quot;0 1 0&quot;</span>, <span class="stringliteral">&quot;0 0 1&quot;</span>};</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>    }</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span> </div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#a19d5202ede86c116129bbe59a83b48b3">   37</a></span>    <span class="keyword">static</span> <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> <a class="code hl_function" href="../../d1/d66/a04273.html#a19d5202ede86c116129bbe59a83b48b3">SetRotationX</a>(<span class="keywordtype">float</span> angle)</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>    {</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>        <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> mat = <span class="keyword">new</span> <a class="code hl_function" href="../../d1/d66/a04273.html#afb1d1e5f93a16088273f76ab8968119d">Matrix3</a>();</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span> </div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>        <span class="keywordtype">float</span> s = Math.Sin(angle);</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>        <span class="keywordtype">float</span> c = Math.Cos(angle);</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span> </div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>        mat.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][1] = c;</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>        mat.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][2] = -s;</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>        mat.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][1] = s;</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>        mat.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][2] = c;</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span> </div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>        <span class="keywordflow">return</span> mat;</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>    }</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span> </div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#ac9c4e46bf6a7fe0a3e399ae928bd6bc1">   52</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d1/d66/a04273.html#ac9c4e46bf6a7fe0a3e399ae928bd6bc1">Set</a>(<span class="keywordtype">int</span> _index, vector _value)</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>    {</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>        <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[_index] = _value;</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>    }</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span> </div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#a0014d8d6919c655bdcffeeb3d6b977d1">   57</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d1/d66/a04273.html#a0014d8d6919c655bdcffeeb3d6b977d1">Set</a>(<span class="keywordtype">int</span> _index, <span class="keywordtype">string</span> _value)</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span>    {</div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>        <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[_index] = _value.ToVector();</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>    }</div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span> </div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#afaaba2ae21336edd4a92b775a0662887">   62</a></span>    vector <a class="code hl_function" href="../../d1/d66/a04273.html#afaaba2ae21336edd4a92b775a0662887">Get</a>(<span class="keywordtype">int</span> _index)</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>    {</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[_index];</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>    }</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span> </div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#aec390f63749a4ba555dcab43f06c0981">   67</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d1/d66/a04273.html#aec390f63749a4ba555dcab43f06c0981">Update</a>()</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>    {</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>        <span class="keywordflow">if</span> (<a class="code hl_variable" href="../../d1/d66/a04273.html#afa212c2ede422da5b0a728c116bd174a">m_trans</a>)</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>            <a class="code hl_variable" href="../../d1/d66/a04273.html#afa212c2ede422da5b0a728c116bd174a">m_trans</a>.<a class="code hl_function" href="../../da/d67/a04281.html#a5b3ebf5f6efdd1e5d668fdefe84cdb16">UpdateBasis</a>();</div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>    }</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span> </div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#a61f79a9de385fabe313e2155a52f365c">   73</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d1/d66/a04273.html#a61f79a9de385fabe313e2155a52f365c">ToQuaternion</a>(out <a class="code hl_class" href="../../d0/d08/a04277.html">Quaternion</a> quat)</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>    {</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>        <span class="keywordflow">if</span> (quat == NULL)</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>            quat = <span class="keyword">new</span> <a class="code hl_class" href="../../d0/d08/a04277.html">Quaternion</a>;</div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span> </div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>        Math3D.MatrixToQuat(<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>, quat.data);</div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span> </div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>        quat.<a class="code hl_function" href="../../d0/d08/a04277.html#ae61f269d43ec60a61e17c627d0226ee6">Update</a>();</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>    }</div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span> </div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#a8ecc0b348cfa0e4923edf0bf4754efd5">   83</a></span>    <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> <a class="code hl_function" href="../../d1/d66/a04273.html#a8ecc0b348cfa0e4923edf0bf4754efd5">Invert</a>()</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>    {</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>        <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> n = <span class="keyword">new</span> <a class="code hl_function" href="../../d1/d66/a04273.html#afb1d1e5f93a16088273f76ab8968119d">Matrix3</a>;</div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span> </div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>        vector co = Vector(<a class="code hl_function" href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">Cofactor</a>(1, 1, 2, 2), <a class="code hl_function" href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">Cofactor</a>(1, 2, 2, 0), <a class="code hl_function" href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">Cofactor</a>(1, 0, 2, 1));</div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span> </div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>        <span class="keywordtype">float</span> det = vector.Dot(<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0], co);</div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>        <span class="keywordflow">if</span> (det == 0)</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>        {</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>            <span class="keywordflow">return</span> n;</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>        }</div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span> </div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>        <span class="keywordtype">float</span> s = 1.0 / det;</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span> </div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][0] = co[0] * s;</div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][1] = <a class="code hl_function" href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">Cofactor</a>(0, 2, 2, 1) * s;</div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][2] = <a class="code hl_function" href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">Cofactor</a>(0, 1, 1, 2) * s;</div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span> </div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][0] = co[1] * s;</div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][1] = <a class="code hl_function" href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">Cofactor</a>(0, 0, 2, 2) * s;</div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][2] = <a class="code hl_function" href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">Cofactor</a>(0, 2, 1, 0) * s;</div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span> </div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][0] = co[2] * s;</div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][1] = <a class="code hl_function" href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">Cofactor</a>(0, 1, 2, 0) * s;</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][2] = <a class="code hl_function" href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">Cofactor</a>(0, 0, 1, 1) * s;</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span> </div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>        <span class="keywordflow">return</span> n;</div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>    }</div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span> </div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#a617bad1cdd7cd30638ac380098dac84c">  112</a></span>    <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> <a class="code hl_function" href="../../d1/d66/a04273.html#a617bad1cdd7cd30638ac380098dac84c">Scaled</a>(vector scale)</div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span>    {</div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>        <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> n = <span class="keyword">new</span> <a class="code hl_function" href="../../d1/d66/a04273.html#afb1d1e5f93a16088273f76ab8968119d">Matrix3</a>;</div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span> </div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][0] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][0] * scale[0];</div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][0] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][0] * scale[1];</div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][0] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][0] * scale[2];</div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span> </div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][1] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][1] * scale[0];</div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][1] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][1] * scale[1];</div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][1] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][1] * scale[2];</div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span> </div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][2] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][2] * scale[0];</div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][2] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][2] * scale[1];</div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][2] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][2] * scale[2];</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span> </div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span>        <span class="keywordflow">return</span> n;</div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>    }</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span> </div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#a45d804698e5fcb3fc2abe65de5653caf">  131</a></span>    <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> <a class="code hl_function" href="../../d1/d66/a04273.html#a45d804698e5fcb3fc2abe65de5653caf">Transpose</a>()</div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>    {</div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>        <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> n = <span class="keyword">new</span> <a class="code hl_function" href="../../d1/d66/a04273.html#afb1d1e5f93a16088273f76ab8968119d">Matrix3</a>;</div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span> </div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][0] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][0];</div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][1] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][0];</div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][2] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][0];</div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span> </div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][0] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][1];</div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][1] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][1];</div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][2] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][1];</div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span> </div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][0] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][2];</div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][1] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][2];</div>
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][2] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][2];</div>
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span> </div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span>        <span class="keywordflow">return</span> n;</div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span>    }</div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span> </div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#ae54a4f20b2699735ca146fc099612865">  150</a></span>    <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> <a class="code hl_function" href="../../d1/d66/a04273.html#ae54a4f20b2699735ca146fc099612865">Adjoint</a>()</div>
<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span>    {</div>
<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span>        <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> n = <span class="keyword">new</span> <a class="code hl_function" href="../../d1/d66/a04273.html#afb1d1e5f93a16088273f76ab8968119d">Matrix3</a>;</div>
<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span> </div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][0] = <a class="code hl_function" href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">Cofactor</a>(1, 1, 2, 2);</div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][1] = <a class="code hl_function" href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">Cofactor</a>(0, 2, 2, 1);</div>
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][2] = <a class="code hl_function" href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">Cofactor</a>(0, 1, 1, 2);</div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span> </div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][0] = <a class="code hl_function" href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">Cofactor</a>(1, 2, 2, 0);</div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][1] = <a class="code hl_function" href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">Cofactor</a>(0, 0, 2, 2);</div>
<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][2] = <a class="code hl_function" href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">Cofactor</a>(0, 2, 1, 0);</div>
<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span> </div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][0] = <a class="code hl_function" href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">Cofactor</a>(1, 0, 2, 1);</div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][1] = <a class="code hl_function" href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">Cofactor</a>(0, 1, 2, 0);</div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][2] = <a class="code hl_function" href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">Cofactor</a>(0, 0, 1, 1);</div>
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span> </div>
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>        <span class="keywordflow">return</span> n;</div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span>    }</div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span> </div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#a0c05ee439631ee68d860df2d81ed4c75">  169</a></span>    <span class="keywordtype">float</span> <a class="code hl_function" href="../../d1/d66/a04273.html#a0c05ee439631ee68d860df2d81ed4c75">TDotX</a>(vector v)</div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>    {</div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][0] * v[0] + <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][0] * v[1] + <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][0] * v[2];</div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>    }</div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span> </div>
<div class="line"><a id="l00174" name="l00174"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#ab4c39a88aef6f852e0222113d1e6ca76">  174</a></span>    <span class="keywordtype">float</span> <a class="code hl_function" href="../../d1/d66/a04273.html#ab4c39a88aef6f852e0222113d1e6ca76">TDotY</a>(vector v)</div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span>    {</div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][1] * v[0] + <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][1] * v[1] + <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][1] * v[2];</div>
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>    }</div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span> </div>
<div class="line"><a id="l00179" name="l00179"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#ab5c38caeec00cb1fc334002aa3b39e14">  179</a></span>    <span class="keywordtype">float</span> <a class="code hl_function" href="../../d1/d66/a04273.html#ab5c38caeec00cb1fc334002aa3b39e14">TDotZ</a>(vector v)</div>
<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span>    {</div>
<div class="line"><a id="l00181" name="l00181"></a><span class="lineno">  181</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][2] * v[0] + <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][2] * v[1] + <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][2] * v[2];</div>
<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span>    }</div>
<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span> </div>
<div class="line"><a id="l00184" name="l00184"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">  184</a></span>    <span class="keywordtype">float</span> <a class="code hl_function" href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">Cofactor</a>(<span class="keywordtype">int</span> r1, <span class="keywordtype">int</span> c1, <span class="keywordtype">int</span> r2, <span class="keywordtype">int</span> c2)</div>
<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span>    {</div>
<div class="line"><a id="l00186" name="l00186"></a><span class="lineno">  186</span>        <span class="keywordtype">float</span> a = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[r1][c1];</div>
<div class="line"><a id="l00187" name="l00187"></a><span class="lineno">  187</span>        <span class="keywordtype">float</span> b = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[r2][c2];</div>
<div class="line"><a id="l00188" name="l00188"></a><span class="lineno">  188</span>        <span class="keywordtype">float</span> c = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[r1][c2];</div>
<div class="line"><a id="l00189" name="l00189"></a><span class="lineno">  189</span>        <span class="keywordtype">float</span> d = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[r2][c1];</div>
<div class="line"><a id="l00190" name="l00190"></a><span class="lineno">  190</span> </div>
<div class="line"><a id="l00191" name="l00191"></a><span class="lineno">  191</span>        <span class="keywordtype">float</span> ab = a * b;</div>
<div class="line"><a id="l00192" name="l00192"></a><span class="lineno">  192</span>        <span class="keywordtype">float</span> cd = c * d;</div>
<div class="line"><a id="l00193" name="l00193"></a><span class="lineno">  193</span>        <span class="keywordtype">float</span> ret = ab - cd;</div>
<div class="line"><a id="l00194" name="l00194"></a><span class="lineno">  194</span> </div>
<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span>        <span class="keywordflow">return</span> ret;</div>
<div class="line"><a id="l00196" name="l00196"></a><span class="lineno">  196</span>    }</div>
<div class="line"><a id="l00197" name="l00197"></a><span class="lineno">  197</span> </div>
<div class="line"><a id="l00198" name="l00198"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#a7c6063ed7dfd914e7f534366a98f5f80">  198</a></span>    vector <a class="code hl_function" href="../../d1/d66/a04273.html#a7c6063ed7dfd914e7f534366a98f5f80">Multiply</a>(vector other)</div>
<div class="line"><a id="l00199" name="l00199"></a><span class="lineno">  199</span>    {</div>
<div class="line"><a id="l00200" name="l00200"></a><span class="lineno">  200</span>        vector n = vector.Zero;</div>
<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span> </div>
<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span>        n[0] = vector.Dot(<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0], other);</div>
<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span>        n[1] = vector.Dot(<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1], other);</div>
<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span>        n[2] = vector.Dot(<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2], other);</div>
<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span> </div>
<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span>        <span class="keywordflow">return</span> n;</div>
<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span>    }</div>
<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span> </div>
<div class="line"><a id="l00209" name="l00209"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#a8597fe59fa808264f81041db8e2df18e">  209</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d1/d66/a04273.html#a8597fe59fa808264f81041db8e2df18e">FromYawPitchRoll</a>(vector ypr)</div>
<div class="line"><a id="l00210" name="l00210"></a><span class="lineno">  210</span>    {</div>
<div class="line"><a id="l00211" name="l00211"></a><span class="lineno">  211</span>        Math3D.YawPitchRollMatrix(ypr, <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>);</div>
<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span> </div>
<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span>        <a class="code hl_function" href="../../d1/d66/a04273.html#aec390f63749a4ba555dcab43f06c0981">Update</a>();</div>
<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span>    }</div>
<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span> </div>
<div class="line"><a id="l00216" name="l00216"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#a153f86bee888a780168b65f66f5a2d70">  216</a></span>    <span class="keyword">static</span> <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> <a class="code hl_function" href="../../d1/d66/a04273.html#a153f86bee888a780168b65f66f5a2d70">YawPitchRoll</a>(vector ypr)</div>
<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span>    {</div>
<div class="line"><a id="l00218" name="l00218"></a><span class="lineno">  218</span>        <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> mat = <span class="keyword">new</span> <a class="code hl_function" href="../../d1/d66/a04273.html#afb1d1e5f93a16088273f76ab8968119d">Matrix3</a>;</div>
<div class="line"><a id="l00219" name="l00219"></a><span class="lineno">  219</span> </div>
<div class="line"><a id="l00220" name="l00220"></a><span class="lineno">  220</span>        Math3D.YawPitchRollMatrix(ypr, mat.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>);</div>
<div class="line"><a id="l00221" name="l00221"></a><span class="lineno">  221</span> </div>
<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span>        mat.<a class="code hl_function" href="../../d1/d66/a04273.html#aec390f63749a4ba555dcab43f06c0981">Update</a>();</div>
<div class="line"><a id="l00223" name="l00223"></a><span class="lineno">  223</span> </div>
<div class="line"><a id="l00224" name="l00224"></a><span class="lineno">  224</span>        <span class="keywordflow">return</span> mat;</div>
<div class="line"><a id="l00225" name="l00225"></a><span class="lineno">  225</span>    }</div>
<div class="line"><a id="l00226" name="l00226"></a><span class="lineno">  226</span> </div>
<div class="line"><a id="l00227" name="l00227"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#a5aae8ad2dd2184243fe842bc1b1391a4">  227</a></span>    vector <a class="code hl_function" href="../../d1/d66/a04273.html#a5aae8ad2dd2184243fe842bc1b1391a4">ToYawPitchRoll</a>()</div>
<div class="line"><a id="l00228" name="l00228"></a><span class="lineno">  228</span>    {</div>
<div class="line"><a id="l00229" name="l00229"></a><span class="lineno">  229</span>        <span class="keywordflow">return</span> Math3D.MatrixToAngles(<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>);</div>
<div class="line"><a id="l00230" name="l00230"></a><span class="lineno">  230</span>    }</div>
<div class="line"><a id="l00231" name="l00231"></a><span class="lineno">  231</span> </div>
<div class="line"><a id="l00232" name="l00232"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#a578167a40c9524dd2eb099a140cad753">  232</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d1/d66/a04273.html#a578167a40c9524dd2eb099a140cad753">Tilda</a>(vector vIn, out <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> mat)</div>
<div class="line"><a id="l00233" name="l00233"></a><span class="lineno">  233</span>    {</div>
<div class="line"><a id="l00234" name="l00234"></a><span class="lineno">  234</span>        <span class="keywordflow">if</span> (mat == NULL)</div>
<div class="line"><a id="l00235" name="l00235"></a><span class="lineno">  235</span>            mat = <span class="keyword">new</span> <a class="code hl_function" href="../../d1/d66/a04273.html#afb1d1e5f93a16088273f76ab8968119d">Matrix3</a>;</div>
<div class="line"><a id="l00236" name="l00236"></a><span class="lineno">  236</span> </div>
<div class="line"><a id="l00237" name="l00237"></a><span class="lineno">  237</span>        mat.data[0][0] = 0.0;</div>
<div class="line"><a id="l00238" name="l00238"></a><span class="lineno">  238</span>        mat.data[1][1] = 0.0;</div>
<div class="line"><a id="l00239" name="l00239"></a><span class="lineno">  239</span>        mat.data[2][2] = 0.0;</div>
<div class="line"><a id="l00240" name="l00240"></a><span class="lineno">  240</span> </div>
<div class="line"><a id="l00241" name="l00241"></a><span class="lineno">  241</span>        mat.data[0][1] = -vIn[2];</div>
<div class="line"><a id="l00242" name="l00242"></a><span class="lineno">  242</span>        mat.data[1][0] = vIn[2];</div>
<div class="line"><a id="l00243" name="l00243"></a><span class="lineno">  243</span>        mat.data[2][0] = -vIn[1];</div>
<div class="line"><a id="l00244" name="l00244"></a><span class="lineno">  244</span>        mat.data[0][2] = vIn[1];</div>
<div class="line"><a id="l00245" name="l00245"></a><span class="lineno">  245</span>        mat.data[1][2] = -vIn[0];</div>
<div class="line"><a id="l00246" name="l00246"></a><span class="lineno">  246</span>        mat.data[2][1] = vIn[0];</div>
<div class="line"><a id="l00247" name="l00247"></a><span class="lineno">  247</span> </div>
<div class="line"><a id="l00248" name="l00248"></a><span class="lineno">  248</span>        mat.Update();</div>
<div class="line"><a id="l00249" name="l00249"></a><span class="lineno">  249</span>    }</div>
<div class="line"><a id="l00250" name="l00250"></a><span class="lineno">  250</span> </div>
<div class="line"><a id="l00251" name="l00251"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#af827546b8646eefd62be458151161f74">  251</a></span>    <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> <a class="code hl_function" href="../../d1/d66/a04273.html#af827546b8646eefd62be458151161f74">Multiply</a>(<a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> m)</div>
<div class="line"><a id="l00252" name="l00252"></a><span class="lineno">  252</span>    {</div>
<div class="line"><a id="l00253" name="l00253"></a><span class="lineno">  253</span>        <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> n = <span class="keyword">new</span> <a class="code hl_function" href="../../d1/d66/a04273.html#afb1d1e5f93a16088273f76ab8968119d">Matrix3</a>;</div>
<div class="line"><a id="l00254" name="l00254"></a><span class="lineno">  254</span> </div>
<div class="line"><a id="l00255" name="l00255"></a><span class="lineno">  255</span>        Math3D.MatrixMultiply3(<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>, m.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>, n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>);</div>
<div class="line"><a id="l00256" name="l00256"></a><span class="lineno">  256</span> </div>
<div class="line"><a id="l00257" name="l00257"></a><span class="lineno">  257</span>        <span class="keywordflow">return</span> n;</div>
<div class="line"><a id="l00258" name="l00258"></a><span class="lineno">  258</span>    }</div>
<div class="line"><a id="l00259" name="l00259"></a><span class="lineno">  259</span> </div>
<div class="line"><a id="l00260" name="l00260"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#af9fdc5c30a6dc2af150f052c3cb57c91">  260</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d1/d66/a04273.html#af9fdc5c30a6dc2af150f052c3cb57c91">Multiply</a>(<a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> m, out <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> n)</div>
<div class="line"><a id="l00261" name="l00261"></a><span class="lineno">  261</span>    {</div>
<div class="line"><a id="l00262" name="l00262"></a><span class="lineno">  262</span>        <span class="keywordflow">if</span> (n == NULL)</div>
<div class="line"><a id="l00263" name="l00263"></a><span class="lineno">  263</span>            n = <span class="keyword">new</span> <a class="code hl_function" href="../../d1/d66/a04273.html#afb1d1e5f93a16088273f76ab8968119d">Matrix3</a>;</div>
<div class="line"><a id="l00264" name="l00264"></a><span class="lineno">  264</span> </div>
<div class="line"><a id="l00265" name="l00265"></a><span class="lineno">  265</span>        Math3D.MatrixMultiply3(<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>, m.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>, n.data);</div>
<div class="line"><a id="l00266" name="l00266"></a><span class="lineno">  266</span>    }</div>
<div class="line"><a id="l00267" name="l00267"></a><span class="lineno">  267</span> </div>
<div class="line"><a id="l00268" name="l00268"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#a5d4f4379b2cb2749cc59d1bcbe98891b">  268</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d1/d66/a04273.html#a5d4f4379b2cb2749cc59d1bcbe98891b">Multiply</a>(<a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> a, <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> b, out <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> n)</div>
<div class="line"><a id="l00269" name="l00269"></a><span class="lineno">  269</span>    {</div>
<div class="line"><a id="l00270" name="l00270"></a><span class="lineno">  270</span>        <span class="keywordflow">if</span> (n == NULL)</div>
<div class="line"><a id="l00271" name="l00271"></a><span class="lineno">  271</span>            n = <span class="keyword">new</span> <a class="code hl_function" href="../../d1/d66/a04273.html#afb1d1e5f93a16088273f76ab8968119d">Matrix3</a>;</div>
<div class="line"><a id="l00272" name="l00272"></a><span class="lineno">  272</span> </div>
<div class="line"><a id="l00273" name="l00273"></a><span class="lineno">  273</span>        Math3D.MatrixMultiply3(a.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>, b.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>, n.data);</div>
<div class="line"><a id="l00274" name="l00274"></a><span class="lineno">  274</span>    }</div>
<div class="line"><a id="l00275" name="l00275"></a><span class="lineno">  275</span> </div>
<div class="line"><a id="l00276" name="l00276"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#a3380ba14e1d92803200a3a37f3b1df5f">  276</a></span>    <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> <a class="code hl_function" href="../../d1/d66/a04273.html#a3380ba14e1d92803200a3a37f3b1df5f">InvMultiply</a>(<a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> m)</div>
<div class="line"><a id="l00277" name="l00277"></a><span class="lineno">  277</span>    {</div>
<div class="line"><a id="l00278" name="l00278"></a><span class="lineno">  278</span>        <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> n = <span class="keyword">new</span> <a class="code hl_function" href="../../d1/d66/a04273.html#afb1d1e5f93a16088273f76ab8968119d">Matrix3</a>;</div>
<div class="line"><a id="l00279" name="l00279"></a><span class="lineno">  279</span> </div>
<div class="line"><a id="l00280" name="l00280"></a><span class="lineno">  280</span>        Math3D.MatrixInvMultiply3(<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>, m.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>, n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>);</div>
<div class="line"><a id="l00281" name="l00281"></a><span class="lineno">  281</span> </div>
<div class="line"><a id="l00282" name="l00282"></a><span class="lineno">  282</span>        <span class="keywordflow">return</span> n;</div>
<div class="line"><a id="l00283" name="l00283"></a><span class="lineno">  283</span>    }</div>
<div class="line"><a id="l00284" name="l00284"></a><span class="lineno">  284</span> </div>
<div class="line"><a id="l00285" name="l00285"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#a46cf3747e78f5e77e72bb941299499f4">  285</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d1/d66/a04273.html#a46cf3747e78f5e77e72bb941299499f4">DirectionAndUp</a>(vector dir, vector up, out <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> mat)</div>
<div class="line"><a id="l00286" name="l00286"></a><span class="lineno">  286</span>    {</div>
<div class="line"><a id="l00287" name="l00287"></a><span class="lineno">  287</span>        <span class="keywordflow">if</span> (mat == NULL)</div>
<div class="line"><a id="l00288" name="l00288"></a><span class="lineno">  288</span>            mat = <span class="keyword">new</span> <a class="code hl_function" href="../../d1/d66/a04273.html#afb1d1e5f93a16088273f76ab8968119d">Matrix3</a>;</div>
<div class="line"><a id="l00289" name="l00289"></a><span class="lineno">  289</span> </div>
<div class="line"><a id="l00290" name="l00290"></a><span class="lineno">  290</span>        vector temp[4];</div>
<div class="line"><a id="l00291" name="l00291"></a><span class="lineno">  291</span>        Math3D.DirectionAndUpMatrix(dir, up, temp);</div>
<div class="line"><a id="l00292" name="l00292"></a><span class="lineno">  292</span> </div>
<div class="line"><a id="l00293" name="l00293"></a><span class="lineno">  293</span>        mat.data[0] = temp[0];</div>
<div class="line"><a id="l00294" name="l00294"></a><span class="lineno">  294</span>        mat.data[1] = temp[1];</div>
<div class="line"><a id="l00295" name="l00295"></a><span class="lineno">  295</span>        mat.data[2] = temp[2];</div>
<div class="line"><a id="l00296" name="l00296"></a><span class="lineno">  296</span>    }</div>
<div class="line"><a id="l00297" name="l00297"></a><span class="lineno">  297</span> </div>
<div class="line"><a id="l00298" name="l00298"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#a45b8452faae7b10bbd9c0eaa6ba3cb1b">  298</a></span>    <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> <a class="code hl_function" href="../../d1/d66/a04273.html#a45b8452faae7b10bbd9c0eaa6ba3cb1b">BISAdd</a>(<a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> m)</div>
<div class="line"><a id="l00299" name="l00299"></a><span class="lineno">  299</span>    {</div>
<div class="line"><a id="l00300" name="l00300"></a><span class="lineno">  300</span>        <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> n = <span class="keyword">new</span> <a class="code hl_function" href="../../d1/d66/a04273.html#afb1d1e5f93a16088273f76ab8968119d">Matrix3</a>;</div>
<div class="line"><a id="l00301" name="l00301"></a><span class="lineno">  301</span> </div>
<div class="line"><a id="l00302" name="l00302"></a><span class="lineno">  302</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0] + m.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0];</div>
<div class="line"><a id="l00303" name="l00303"></a><span class="lineno">  303</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1] + m.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1];</div>
<div class="line"><a id="l00304" name="l00304"></a><span class="lineno">  304</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2] + m.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2];</div>
<div class="line"><a id="l00305" name="l00305"></a><span class="lineno">  305</span> </div>
<div class="line"><a id="l00306" name="l00306"></a><span class="lineno">  306</span>        <span class="keywordflow">return</span> n;</div>
<div class="line"><a id="l00307" name="l00307"></a><span class="lineno">  307</span>    }</div>
<div class="line"><a id="l00308" name="l00308"></a><span class="lineno">  308</span> </div>
<div class="line"><a id="l00309" name="l00309"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#aff7ae49a29017f740ebbb7c05d85388e">  309</a></span>    <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> <a class="code hl_function" href="../../d1/d66/a04273.html#aff7ae49a29017f740ebbb7c05d85388e">BISSubtract</a>(<a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> m)</div>
<div class="line"><a id="l00310" name="l00310"></a><span class="lineno">  310</span>    {</div>
<div class="line"><a id="l00311" name="l00311"></a><span class="lineno">  311</span>        <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> n = <span class="keyword">new</span> <a class="code hl_function" href="../../d1/d66/a04273.html#afb1d1e5f93a16088273f76ab8968119d">Matrix3</a>;</div>
<div class="line"><a id="l00312" name="l00312"></a><span class="lineno">  312</span> </div>
<div class="line"><a id="l00313" name="l00313"></a><span class="lineno">  313</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0] - m.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0];</div>
<div class="line"><a id="l00314" name="l00314"></a><span class="lineno">  314</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1] - m.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1];</div>
<div class="line"><a id="l00315" name="l00315"></a><span class="lineno">  315</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2] - m.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2];</div>
<div class="line"><a id="l00316" name="l00316"></a><span class="lineno">  316</span> </div>
<div class="line"><a id="l00317" name="l00317"></a><span class="lineno">  317</span>        <span class="keywordflow">return</span> n;</div>
<div class="line"><a id="l00318" name="l00318"></a><span class="lineno">  318</span>    }</div>
<div class="line"><a id="l00319" name="l00319"></a><span class="lineno">  319</span> </div>
<div class="line"><a id="l00320" name="l00320"></a><span class="lineno"><a class="line" href="../../d1/d66/a04273.html#a1223d3c51d9cad6bf834d63ffa709a7b">  320</a></span>    <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> <a class="code hl_function" href="../../d1/d66/a04273.html#a1223d3c51d9cad6bf834d63ffa709a7b">BISMultiply</a>(<span class="keywordtype">float</span> m)</div>
<div class="line"><a id="l00321" name="l00321"></a><span class="lineno">  321</span>    {</div>
<div class="line"><a id="l00322" name="l00322"></a><span class="lineno">  322</span>        <a class="code hl_class" href="../../d1/d66/a04273.html">Matrix3</a> n = <span class="keyword">new</span> <a class="code hl_function" href="../../d1/d66/a04273.html#afb1d1e5f93a16088273f76ab8968119d">Matrix3</a>;</div>
<div class="line"><a id="l00323" name="l00323"></a><span class="lineno">  323</span> </div>
<div class="line"><a id="l00324" name="l00324"></a><span class="lineno">  324</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][0] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][0] * m;</div>
<div class="line"><a id="l00325" name="l00325"></a><span class="lineno">  325</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][0] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][0] * m;</div>
<div class="line"><a id="l00326" name="l00326"></a><span class="lineno">  326</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][0] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][0] * m;</div>
<div class="line"><a id="l00327" name="l00327"></a><span class="lineno">  327</span> </div>
<div class="line"><a id="l00328" name="l00328"></a><span class="lineno">  328</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][1] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][1] * m;</div>
<div class="line"><a id="l00329" name="l00329"></a><span class="lineno">  329</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][1] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][1] * m;</div>
<div class="line"><a id="l00330" name="l00330"></a><span class="lineno">  330</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][1] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][1] * m;</div>
<div class="line"><a id="l00331" name="l00331"></a><span class="lineno">  331</span> </div>
<div class="line"><a id="l00332" name="l00332"></a><span class="lineno">  332</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][2] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0][2] * m;</div>
<div class="line"><a id="l00333" name="l00333"></a><span class="lineno">  333</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][2] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1][2] * m;</div>
<div class="line"><a id="l00334" name="l00334"></a><span class="lineno">  334</span>        n.<a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][2] = <a class="code hl_variable" href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2][2] * m;</div>
<div class="line"><a id="l00335" name="l00335"></a><span class="lineno">  335</span> </div>
<div class="line"><a id="l00336" name="l00336"></a><span class="lineno">  336</span>        <span class="keywordflow">return</span> n;</div>
<div class="line"><a id="l00337" name="l00337"></a><span class="lineno">  337</span>    }</div>
<div class="line"><a id="l00338" name="l00338"></a><span class="lineno">  338</span>};</div>
<div class="ttc" id="aa04273_html"><div class="ttname"><a href="../../d1/d66/a04273.html">Matrix3</a></div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00013">matrix3.c:14</a></div></div>
<div class="ttc" id="aa04273_html_a0014d8d6919c655bdcffeeb3d6b977d1"><div class="ttname"><a href="../../d1/d66/a04273.html#a0014d8d6919c655bdcffeeb3d6b977d1">Matrix3::Set</a></div><div class="ttdeci">void Set(int _index, string _value)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00057">matrix3.c:57</a></div></div>
<div class="ttc" id="aa04273_html_a0c05ee439631ee68d860df2d81ed4c75"><div class="ttname"><a href="../../d1/d66/a04273.html#a0c05ee439631ee68d860df2d81ed4c75">Matrix3::TDotX</a></div><div class="ttdeci">float TDotX(vector v)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00169">matrix3.c:169</a></div></div>
<div class="ttc" id="aa04273_html_a1223d3c51d9cad6bf834d63ffa709a7b"><div class="ttname"><a href="../../d1/d66/a04273.html#a1223d3c51d9cad6bf834d63ffa709a7b">Matrix3::BISMultiply</a></div><div class="ttdeci">Matrix3 BISMultiply(float m)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00320">matrix3.c:320</a></div></div>
<div class="ttc" id="aa04273_html_a1288ceb8ba5e8307216208c3ba127b15"><div class="ttname"><a href="../../d1/d66/a04273.html#a1288ceb8ba5e8307216208c3ba127b15">Matrix3::Transpose</a></div><div class="ttdeci">static void Transpose(vector a[3], out vector b[3])</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00019">matrix3.c:19</a></div></div>
<div class="ttc" id="aa04273_html_a153f86bee888a780168b65f66f5a2d70"><div class="ttname"><a href="../../d1/d66/a04273.html#a153f86bee888a780168b65f66f5a2d70">Matrix3::YawPitchRoll</a></div><div class="ttdeci">static Matrix3 YawPitchRoll(vector ypr)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00216">matrix3.c:216</a></div></div>
<div class="ttc" id="aa04273_html_a19d5202ede86c116129bbe59a83b48b3"><div class="ttname"><a href="../../d1/d66/a04273.html#a19d5202ede86c116129bbe59a83b48b3">Matrix3::SetRotationX</a></div><div class="ttdeci">static Matrix3 SetRotationX(float angle)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00037">matrix3.c:37</a></div></div>
<div class="ttc" id="aa04273_html_a3380ba14e1d92803200a3a37f3b1df5f"><div class="ttname"><a href="../../d1/d66/a04273.html#a3380ba14e1d92803200a3a37f3b1df5f">Matrix3::InvMultiply</a></div><div class="ttdeci">Matrix3 InvMultiply(Matrix3 m)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00276">matrix3.c:276</a></div></div>
<div class="ttc" id="aa04273_html_a45b8452faae7b10bbd9c0eaa6ba3cb1b"><div class="ttname"><a href="../../d1/d66/a04273.html#a45b8452faae7b10bbd9c0eaa6ba3cb1b">Matrix3::BISAdd</a></div><div class="ttdeci">Matrix3 BISAdd(Matrix3 m)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00298">matrix3.c:298</a></div></div>
<div class="ttc" id="aa04273_html_a45d804698e5fcb3fc2abe65de5653caf"><div class="ttname"><a href="../../d1/d66/a04273.html#a45d804698e5fcb3fc2abe65de5653caf">Matrix3::Transpose</a></div><div class="ttdeci">Matrix3 Transpose()</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00131">matrix3.c:131</a></div></div>
<div class="ttc" id="aa04273_html_a46cf3747e78f5e77e72bb941299499f4"><div class="ttname"><a href="../../d1/d66/a04273.html#a46cf3747e78f5e77e72bb941299499f4">Matrix3::DirectionAndUp</a></div><div class="ttdeci">static void DirectionAndUp(vector dir, vector up, out Matrix3 mat)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00285">matrix3.c:285</a></div></div>
<div class="ttc" id="aa04273_html_a578167a40c9524dd2eb099a140cad753"><div class="ttname"><a href="../../d1/d66/a04273.html#a578167a40c9524dd2eb099a140cad753">Matrix3::Tilda</a></div><div class="ttdeci">static void Tilda(vector vIn, out Matrix3 mat)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00232">matrix3.c:232</a></div></div>
<div class="ttc" id="aa04273_html_a5aae8ad2dd2184243fe842bc1b1391a4"><div class="ttname"><a href="../../d1/d66/a04273.html#a5aae8ad2dd2184243fe842bc1b1391a4">Matrix3::ToYawPitchRoll</a></div><div class="ttdeci">vector ToYawPitchRoll()</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00227">matrix3.c:227</a></div></div>
<div class="ttc" id="aa04273_html_a5d4f4379b2cb2749cc59d1bcbe98891b"><div class="ttname"><a href="../../d1/d66/a04273.html#a5d4f4379b2cb2749cc59d1bcbe98891b">Matrix3::Multiply</a></div><div class="ttdeci">static void Multiply(Matrix3 a, Matrix3 b, out Matrix3 n)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00268">matrix3.c:268</a></div></div>
<div class="ttc" id="aa04273_html_a617bad1cdd7cd30638ac380098dac84c"><div class="ttname"><a href="../../d1/d66/a04273.html#a617bad1cdd7cd30638ac380098dac84c">Matrix3::Scaled</a></div><div class="ttdeci">Matrix3 Scaled(vector scale)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00112">matrix3.c:112</a></div></div>
<div class="ttc" id="aa04273_html_a61f79a9de385fabe313e2155a52f365c"><div class="ttname"><a href="../../d1/d66/a04273.html#a61f79a9de385fabe313e2155a52f365c">Matrix3::ToQuaternion</a></div><div class="ttdeci">void ToQuaternion(out Quaternion quat)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00073">matrix3.c:73</a></div></div>
<div class="ttc" id="aa04273_html_a7c6063ed7dfd914e7f534366a98f5f80"><div class="ttname"><a href="../../d1/d66/a04273.html#a7c6063ed7dfd914e7f534366a98f5f80">Matrix3::Multiply</a></div><div class="ttdeci">vector Multiply(vector other)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00198">matrix3.c:198</a></div></div>
<div class="ttc" id="aa04273_html_a8597fe59fa808264f81041db8e2df18e"><div class="ttname"><a href="../../d1/d66/a04273.html#a8597fe59fa808264f81041db8e2df18e">Matrix3::FromYawPitchRoll</a></div><div class="ttdeci">void FromYawPitchRoll(vector ypr)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00209">matrix3.c:209</a></div></div>
<div class="ttc" id="aa04273_html_a8ecc0b348cfa0e4923edf0bf4754efd5"><div class="ttname"><a href="../../d1/d66/a04273.html#a8ecc0b348cfa0e4923edf0bf4754efd5">Matrix3::Invert</a></div><div class="ttdeci">Matrix3 Invert()</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00083">matrix3.c:83</a></div></div>
<div class="ttc" id="aa04273_html_a91e02ed005a7e173a36504fc5e5f4fa9"><div class="ttname"><a href="../../d1/d66/a04273.html#a91e02ed005a7e173a36504fc5e5f4fa9">Matrix3::data</a></div><div class="ttdeci">vector data[3]</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00015">matrix3.c:15</a></div></div>
<div class="ttc" id="aa04273_html_a9d981e7d5bf825458fe2fa0562b525ad"><div class="ttname"><a href="../../d1/d66/a04273.html#a9d981e7d5bf825458fe2fa0562b525ad">Matrix3::Cofactor</a></div><div class="ttdeci">float Cofactor(int r1, int c1, int r2, int c2)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00184">matrix3.c:184</a></div></div>
<div class="ttc" id="aa04273_html_ab4c39a88aef6f852e0222113d1e6ca76"><div class="ttname"><a href="../../d1/d66/a04273.html#ab4c39a88aef6f852e0222113d1e6ca76">Matrix3::TDotY</a></div><div class="ttdeci">float TDotY(vector v)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00174">matrix3.c:174</a></div></div>
<div class="ttc" id="aa04273_html_ab5c38caeec00cb1fc334002aa3b39e14"><div class="ttname"><a href="../../d1/d66/a04273.html#ab5c38caeec00cb1fc334002aa3b39e14">Matrix3::TDotZ</a></div><div class="ttdeci">float TDotZ(vector v)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00179">matrix3.c:179</a></div></div>
<div class="ttc" id="aa04273_html_ac9c4e46bf6a7fe0a3e399ae928bd6bc1"><div class="ttname"><a href="../../d1/d66/a04273.html#ac9c4e46bf6a7fe0a3e399ae928bd6bc1">Matrix3::Set</a></div><div class="ttdeci">void Set(int _index, vector _value)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00052">matrix3.c:52</a></div></div>
<div class="ttc" id="aa04273_html_ae54a4f20b2699735ca146fc099612865"><div class="ttname"><a href="../../d1/d66/a04273.html#ae54a4f20b2699735ca146fc099612865">Matrix3::Adjoint</a></div><div class="ttdeci">Matrix3 Adjoint()</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00150">matrix3.c:150</a></div></div>
<div class="ttc" id="aa04273_html_aec390f63749a4ba555dcab43f06c0981"><div class="ttname"><a href="../../d1/d66/a04273.html#aec390f63749a4ba555dcab43f06c0981">Matrix3::Update</a></div><div class="ttdeci">void Update()</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00067">matrix3.c:67</a></div></div>
<div class="ttc" id="aa04273_html_af827546b8646eefd62be458151161f74"><div class="ttname"><a href="../../d1/d66/a04273.html#af827546b8646eefd62be458151161f74">Matrix3::Multiply</a></div><div class="ttdeci">Matrix3 Multiply(Matrix3 m)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00251">matrix3.c:251</a></div></div>
<div class="ttc" id="aa04273_html_af9fdc5c30a6dc2af150f052c3cb57c91"><div class="ttname"><a href="../../d1/d66/a04273.html#af9fdc5c30a6dc2af150f052c3cb57c91">Matrix3::Multiply</a></div><div class="ttdeci">void Multiply(Matrix3 m, out Matrix3 n)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00260">matrix3.c:260</a></div></div>
<div class="ttc" id="aa04273_html_afa212c2ede422da5b0a728c116bd174a"><div class="ttname"><a href="../../d1/d66/a04273.html#afa212c2ede422da5b0a728c116bd174a">Matrix3::m_trans</a></div><div class="ttdeci">Transform m_trans</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00017">matrix3.c:17</a></div></div>
<div class="ttc" id="aa04273_html_afaaba2ae21336edd4a92b775a0662887"><div class="ttname"><a href="../../d1/d66/a04273.html#afaaba2ae21336edd4a92b775a0662887">Matrix3::Get</a></div><div class="ttdeci">vector Get(int _index)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00062">matrix3.c:62</a></div></div>
<div class="ttc" id="aa04273_html_afb1d1e5f93a16088273f76ab8968119d"><div class="ttname"><a href="../../d1/d66/a04273.html#afb1d1e5f93a16088273f76ab8968119d">Matrix3::Matrix3</a></div><div class="ttdeci">void Matrix3()</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00032">matrix3.c:32</a></div></div>
<div class="ttc" id="aa04273_html_aff7ae49a29017f740ebbb7c05d85388e"><div class="ttname"><a href="../../d1/d66/a04273.html#aff7ae49a29017f740ebbb7c05d85388e">Matrix3::BISSubtract</a></div><div class="ttdeci">Matrix3 BISSubtract(Matrix3 m)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/de8/a00839_source.html#l00309">matrix3.c:309</a></div></div>
<div class="ttc" id="aa04277_html"><div class="ttname"><a href="../../d0/d08/a04277.html">Quaternion</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d11/a00842_source.html#l00013">quaternion.c:14</a></div></div>
<div class="ttc" id="aa04277_html_ae61f269d43ec60a61e17c627d0226ee6"><div class="ttname"><a href="../../d0/d08/a04277.html#ae61f269d43ec60a61e17c627d0226ee6">Quaternion::Update</a></div><div class="ttdeci">void Update()</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d11/a00842_source.html#l00024">quaternion.c:24</a></div></div>
<div class="ttc" id="aa04281_html"><div class="ttname"><a href="../../da/d67/a04281.html">Transform</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d7/dcf/a00845_source.html#l00013">transform.c:14</a></div></div>
<div class="ttc" id="aa04281_html_a5b3ebf5f6efdd1e5d668fdefe84cdb16"><div class="ttname"><a href="../../da/d67/a04281.html#a5b3ebf5f6efdd1e5d668fdefe84cdb16">Transform::UpdateBasis</a></div><div class="ttdeci">void UpdateBasis()</div><div class="ttdef"><b>Definition:</b> <a href="../../d7/dcf/a00845_source.html#l00141">transform.c:141</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_6127fff2da0a20e2dc2cd9302c584350.html">DayzExpansion</a></li><li class="navelem"><a class="el" href="../../dir_fa1f4f079ed95106cba6603012ba90d8.html">Core</a></li><li class="navelem"><a class="el" href="../../dir_4763e2204ca4935d3e08fff4ec8c41d9.html">Scripts</a></li><li class="navelem"><a class="el" href="../../dir_f7c621fee0a2c32a175ba0589ac46b9f.html">3_game</a></li><li class="navelem"><a class="el" href="../../dir_9ddfc87c5f9b9fe1ae81092761181e6d.html">dayzexpansion_core</a></li><li class="navelem"><a class="el" href="../../dir_7e09f36e26b2f663af36ec1f2c2fe1df.html">math</a></li><li class="navelem"><a class="el" href="../../df/de8/a00839.html">matrix3.c</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
